searchNodes=[{"doc":"Bubblescript Matching Language (BML) BML is a rule language for matching natural language against a rule base. Think of it as regular expressions for sentences . Whereas regular expressions work on individual characters, BML rules primarily work on a tokenized representation of the string. BML ships with a builtin string tokenizer, but for production usage you should look into using a language-specific tokenizer, e.g. to use the output of Spacy's Doc.to_json function. The full documentation on the BML syntax and the API reference is available on hexdocs.pm . To try out BML, check out the demo environment , powered by Phoenix Liveview. Examples Matching basic sequences of words: Match string Example Matches? hello world Hello, world! yes hello world Well hello world yes hello world hello there world no hello world world hello no Matching regular expressions: Match string Example Matches? /[a-z]+/ abcd yes Match entities, with the help of Spacy and Duckling preprocessing and tokenizing the input: Match string Matches Does not match [person] George Baker Hello world [time] I walked to the store yesterday My name is John Rules overview The match syntax is composed of adjacent and optionally nested, rules. Each individual has the following syntax: Basic words hello world Basic words; rules consisting of only alphanumeric characters. Matching is done on both the lowercased, normalized, accents-removed version of the word, and on the lemmatization of the word. The lemma of a word is its base version; e.g. for verbs it is the root form (are → be, went → go); for nouns it is the singular form of the word. Some languages (german, dutch, …) have compound nouns , that are often written both with and without spaces or dashes. Use a dash ( - ) to match on such compound nouns: the rule was-machine matches all of wasmachine , was-machine and was machine . The apostrophe sign is also supported as part of a word, for instance when matching something like Martha's cookies . In this case, the apostrophe 's part is called the particle . For places where the apostrophe is a verb, e.g. in he'll do that , you can write the verb (&quot;will&quot;) in full in the BML, as Spacy will determine the proper verb. In that case, the BML query would be he will do that , which would also match the version with the apostrophe. Same goes for don't , he's , etc. Literals &quot;Literal word sequence&quot; Matches a literal piece of text, which can span multiple tokens. Matching is case insensitive , and also insensitive to the presence of accented characters. Ignoring tokens: _ hello _ world The standalone occurence of _ matches 0-5 of any available token, non-greedy. This can be used in places where you expect a few tokens to occur but you don't care about the tokens. Matching a range of tokens [1] match exactly one token; any token [2+] match 2 or more tokens (greedy) [1-3] match 1 to 3 tokens (greedy) [2+?] match 2 or more tokens (non-greedy) [1-3?] match 1 to 3 tokens (non-greedy) Use this when you know how many tokens you need to match, but it does not matter what the contents of the tokens is. Entities Entity tokens: [email] matches a token of type :entity with value.kind == email . Entities are extracted by external means, e.g. by an NLP NER engine like Duckling. Entities are automatically captured under a variable with the same name as the entity's kind. The default list of supported entities is the following: amount_of_money (duckling) credit_card_number (duckling) date (spacy) distance (duckling) duration (duckling) email (duckling) event (spacy) fac (spacy) gpe (spacy) language (spacy) law (spacy) loc (spacy) money (spacy) norp (spacy) number (duckling) ordinal (duckling) org (spacy) percent (spacy) person (spacy) phone_number (duckling) product (spacy) quantity (duckling) temperature (duckling) time (duckling) url (duckling) volume (duckling) work_of_art (spacy) From our experience, Duckling entities work much better than Spacy entities, and are preferred for use. Besides being more accurate, the Duckling entities also provide more metadata, like valid UTC times when a date is recognized. Regular expressions /regex/ Matches the given regex against the sentence. Regexes can span multiple tokens, thus you can match on whitespace and other token separators. Regular expressions are case insensitive . Regular expression named capture groups are also supported, to capture a specific part of a string: /KL(?&lt;flight_number&gt;\\d+)/ matches KL12345 and extracts 12345 as the flight_number capture. Per-token regular expressions /regex/T The special regex flag T is used to indicate that the regex should be run against a single token instead of against the raw text of the sentence. This will make the regex capturing much more 'narrow'. The regex start and end symbols ( ^ and $ ) are automatically added to the regex, so eg the BML /\\d{4}/T will match the token &quot;1234&quot; but not &quot;12345&quot;. OR / grouping construct Use parentheses combined with the pipe | character to specify an OR clause. pizza | fries | chicken - OR-clause on the root level without parens, matches either token a ( a | b | c ) - use parentheses to separate OR-clauses; matches one token consisting of first a , and then a , b or c . ( hi | hello )[=greeting] matches 1 token and stores it in greeting Parenthesis with | can also be used to capture a sequence of tokens together as one group: ( a )[3+] matches 3 or more token consisting of a Permutation construct The permutation construct using pointy brackets, &lt; , &gt; matches the given rules in no particular order. &lt; a b c &gt; matches any permutation of the sequence a b c ; a c b , or b a c , or c a b , etc An implicit _ is inserted between all rules. So the rule &lt;a b&gt; can also be written as (a _ b | b _ a) . Start / end sentence markers To match the beginning of end of sentences, the following constructs can be used: [Start] Matches the start of a sentence [End] Matches the end of a sentence The [Start] and [End] symbols are not always the same as the start and end of the input string, as sometimes the user input is split into multiple sentences, based on the Spacy sentence tokenizer. Part-of-speech tags (word kinds) To be able to disambiguate between word kinds, the % construct matches on the POS-tag of a token: %VERB matches any verb %NOUN matches any noun Any other POS Spacy tags are valid as well. Optionality modifier An appended ? makes the given rule optional (it needs to occur 0 or 1 times). Repetition modifier Any rule can have a [] block which contains a repetition modifier and/or a capture expression. a[1] match exactly one a word a[2+] match 2 or more a 's (greedy) a[1-3] match 1 to 3 a 's (greedy) a[2+?] match 2 or more a 's (non-greedy) a[1-3?] match 1 to 3 a 's (non-greedy) Capture modifier (my name is _)[=x] stores the entire token sequence &quot;My name is john&quot; Punctuation Punctuation is optional, and can be ignored while creating match rules. However, punctuation tokens are stored in the tokenized version of the input; in fact, multiple tokenizations of the input are stored for each sentence, one without and one with with the punctuation. The sentence Hello, world. is stored both as: Hello world Hello , world . Matching punctuation can be done by including the punctuation into ' literal quotes. Sentence tokenization The expression matching works on a per-sentence basis; the idea is that it does not make sense to create expressions that span over sentences. The builtin sentence tokenizer ( BubbleMatch.Sentence.Tokenizer ) does not have the concept of sentences, and thus treats each input as a single sentence, even in the existence of periods in the input. However, the prefered way of using this library is by running the input through an NLP preprocessor like Spacy, which does tokenize an input into individual sentences. Sigil For use within Elixir, it is possible to use a ~m sigil which parses the given BML query on compile-time: defmodule MyModule do use BubbleMatch.Sigil def greeting? ( input ) do BubbleMatch . match ( ~m&quot;hello | hi | howdy&quot; , input ) != :nomatch end end Installation If available in Hex , the package can be installed by adding bubble_match to your list of dependencies in mix.exs : def deps do [ { :bubble_match , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/bubble_match .","ref":"BubbleMatch.html","title":"BubbleMatch","type":"module"},{"doc":"Match a given input against a BML query.","ref":"BubbleMatch.html#match/2","title":"BubbleMatch.match/2","type":"function"},{"doc":"Parse a string into a BML expression.","ref":"BubbleMatch.html#parse/2","title":"BubbleMatch.parse/2","type":"function"},{"doc":"Parse a string into a BML expression, raises on error.","ref":"BubbleMatch.html#parse!/2","title":"BubbleMatch.parse!/2","type":"function"},{"doc":"","ref":"BubbleMatch.html#t:input/0","title":"BubbleMatch.input/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:match_result/0","title":"BubbleMatch.match_result/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:parse_opt/0","title":"BubbleMatch.parse_opt/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:parse_opts/0","title":"BubbleMatch.parse_opts/0","type":"type"},{"doc":"","ref":"BubbleMatch.html#t:t/0","title":"BubbleMatch.t/0","type":"type"},{"doc":"","ref":"BubbleMatch.Entity.html","title":"BubbleMatch.Entity","type":"module"},{"doc":"","ref":"BubbleMatch.Entity.html#new/5","title":"BubbleMatch.Entity.new/5","type":"function"},{"doc":"A data structure which holds a tokenized sentence. The struct contains the text of the sentence (in the text property), and a list of tokenizations . Normally, a sentence has just one tokenization, but adding entities to the sentence might cause several tokens in the sentence to be replaed with an entity token, thus creating the need for multiple tokenizations (as you still might want to match on the original sentence, e.g. in the case of a falsely identified entitiy)","ref":"BubbleMatch.Sentence.html","title":"BubbleMatch.Sentence","type":"module"},{"doc":"Enrich the given sentence with entities extracted via Duckling This function takes the output of the Duckling JSON format and enriches the given sentence with the entities that were found using Duckling.","ref":"BubbleMatch.Sentence.html#add_duckling_entities/2","title":"BubbleMatch.Sentence.add_duckling_entities/2","type":"function"},{"doc":"Convert a JSON blob from Spacy NLP data into a sentence. This function takes the output of Spacy's Doc.to_json function and converts it into a sentence. Note that the Spacy tokenizer detects multiple sentences. However, in many cases the result is suboptimal and therefore we always construct a single sentence, given our use case of chat messages.","ref":"BubbleMatch.Sentence.html#from_spacy/1","title":"BubbleMatch.Sentence.from_spacy/1","type":"function"},{"doc":"Tokenize an input into individual tokens. As the name suggests, this tokenization is quite naive. It only splits strings on whitespace and punctuation, disregarding any language-specific information. However, for 'basic' use cases, and for our test suite, it is good enough.","ref":"BubbleMatch.Sentence.html#naive_tokenize/1","title":"BubbleMatch.Sentence.naive_tokenize/1","type":"function"},{"doc":"","ref":"BubbleMatch.Sentence.html#t:t/0","title":"BubbleMatch.Sentence.t/0","type":"type"},{"doc":"","ref":"BubbleMatch.Sigil.html","title":"BubbleMatch.Sigil","type":"module"},{"doc":"Define the ~m sigil for compile-time parsing of BML expressions. For use within Elixir it is possible to use a ~m sigil which parses the given BML query on compile-time: defmodule MyModule do use BubbleMatch.Sigil def greeting? ( input ) do BubbleMatch . match ( ~m&quot;hello | hi | howdy&quot; , input ) != :nomatch end end","ref":"BubbleMatch.Sigil.html#sigil_m/2","title":"BubbleMatch.Sigil.sigil_m/2","type":"macro"},{"doc":"A token is a single word or a part of the sentence. A sentence is a sequence of tokens. Each token contains information and metadata that is used to match sentences on, and to extract information from.","ref":"BubbleMatch.Token.html","title":"BubbleMatch.Token","type":"module"},{"doc":"Get the base form of the given string; the downcased, ASCII version.","ref":"BubbleMatch.Token.html#base_form/1","title":"BubbleMatch.Token.base_form/1","type":"function"},{"doc":"Test whether a token is an entity of the given kind.","ref":"BubbleMatch.Token.html#entity?/2","title":"BubbleMatch.Token.entity?/2","type":"function"},{"doc":"Constructs a token from a Duckling entity definition","ref":"BubbleMatch.Token.html#from_duckling_entity/1","title":"BubbleMatch.Token.from_duckling_entity/1","type":"function"},{"doc":"Given a single token in Spacy's JSON format, convert it into a token.","ref":"BubbleMatch.Token.html#from_spacy/1","title":"BubbleMatch.Token.from_spacy/1","type":"function"},{"doc":"Constructs a token from a Spacy entity definition","ref":"BubbleMatch.Token.html#from_spacy_entity/2","title":"BubbleMatch.Token.from_spacy_entity/2","type":"function"},{"doc":"Test whether a token mathces the given POS (part-of-speech) tag.","ref":"BubbleMatch.Token.html#pos?/2","title":"BubbleMatch.Token.pos?/2","type":"function"},{"doc":"Test whether a token is punctuation","ref":"BubbleMatch.Token.html#punct?/1","title":"BubbleMatch.Token.punct?/1","type":"function"},{"doc":"Test whether a token matches the given (optionally normalized) word.","ref":"BubbleMatch.Token.html#word?/2","title":"BubbleMatch.Token.word?/2","type":"function"},{"doc":"Tokens contain the following fields: raw - the raw text value of the token, including any surrounding whitespace. value - the normalized value of the token. In the case of word tokens, this is usually the normalized, lowercased version of the word. In the case of entities, this value holds a map with keys kind , provider and value . start - the start index; where in the original sentence the token starts. end - the end index; where in the original sentence the token ends. index - the (zero-based) token index number; 0 if it's the first token, 1 if it's the second, etc. type - the type of the token; an atom, holding either :entity , :spacy , :naive , depending on the way the token was originally created.","ref":"BubbleMatch.Token.html#t:t/0","title":"BubbleMatch.Token.t/0","type":"type"},{"doc":"Documentation for Unidekode.","ref":"BubbleMatch.Unidekode.html","title":"BubbleMatch.Unidekode","type":"module"},{"doc":"Remove accented characters from the string, but keeping special characters like emoji Examples iex&gt; BubbleMatch.Unidekode . drop_accented ( &quot;código&quot; ) &quot;codigo&quot; iex&gt; BubbleMatch.Unidekode . drop_accented ( &quot;código 👍&quot; ) &quot;codigo 👍&quot;","ref":"BubbleMatch.Unidekode.html#drop_accented/1","title":"BubbleMatch.Unidekode.drop_accented/1","type":"function"},{"doc":"Transliterate Unicode characters to US-ASCII. Examples iex&gt; BubbleMatch.Unidekode . to_ascii ( &quot;código&quot; ) &quot;codigo&quot; iex&gt; BubbleMatch.Unidekode . to_ascii ( &quot;código😀&quot; ) &quot;codigo&quot; iex&gt; BubbleMatch.Unidekode . to_ascii ( &#39;código&#39; ) &#39;codigo&#39; iex&gt; BubbleMatch.Unidekode . to_ascii ( &#39;código℗&#39; ) &#39;codigo&#39;","ref":"BubbleMatch.Unidekode.html#to_ascii/1","title":"BubbleMatch.Unidekode.to_ascii/1","type":"function"}]